dpdom = function(A) {
# This program finds a permutation that maximizes 
# the dominance index using dynamic programming. 
# INPUTS
#     A - an n x n asymmetric network matrix
# OUTPUTS
#	domidx - the optimal value of the dominance index (above-diag sum)
#	x - an nx1 vector containing the sequence of the objects
#       ttime - the total time consumed by the algorithm
	N = dim(A)[1]
        Z = 0
        TIMTOT = 0
	IPERM <- matrix(0, nrow = N, ncol = 1)
	dyn.load("c:/seriation/dpdom.dll")
	resdom =.Fortran("dpdom",as.integer(N),as.double(A),as.double(Z),as.double(TIMTOT),as.integer(IPERM))
	p <- as.numeric(as.character(unlist(resdom[5])))
	x <<- matrix(p, nrow = N, ncol = 1)
	domidx <<- resdom[3]
	ttime <<- resdom[4]
}
