dprob = function(A) {
# This program finds a permutation that minimizes
# a QAP-type index using dynamic programming.
# The goal is to induce a Robinson structure 
# INPUTS
#     A - an n x n symmetric network matrix
# OUTPUTS
#	robidx - the optimal value of the QAP-type index 
#	x - an nx1 vector containing the sequence of the objects
#       ttime - the total time consumed by the algorithm
	N = dim(A)[1]
        Z = 0
        TIMTOT = 0
	IPERM <- matrix(0, nrow = N, ncol = 1)
	dyn.load("c:/seriation/dprob.dll")
	resrob =.Fortran("dprob",as.integer(N),as.double(A),as.double(Z),as.double(TIMTOT),as.integer(IPERM))
	p <- as.numeric(as.character(unlist(resrob[5])))
	x <<- matrix(p, nrow = N, ncol = 1)
	robidx <<- resrob[3]
	ttime <<- resrob[4]
}
