sarob1 = function(A,NREPS) {
# This program finds a permutation that minimizes
# a QAP-type index using simulated annealing
# The goal is to induce a Robinson structure 
# INPUTS
#     A - an n x n symmetric network matrix
# OUTPUTS
#	robidx - the optimal value of the QAP-type index 
#	x - an nx1 vector containing the sequence of the objects
#       attract - the percentage of times -- out of 20 -- the best solutions 
#       ttime - the total time consumed by the algorithm
	N = dim(A)[1]
        ZMIN = 0
        TIMTOT = 0
        ATTR = 0
	GB <- matrix(0, nrow = N, ncol = 1)
	dyn.load("c:/seriation/sarob1.dll")
	resrob =.Fortran("sarob1",as.integer(N),as.double(A),as.double(ZMIN),as.double(ATTR),as.double(TIMTOT),as.integer(GB),as.integer(NREPS))
	p <- as.numeric(as.character(unlist(resrob[6])))
	x <<- matrix(p, nrow = N, ncol = 1)
	robidx <<- resrob[3]
	attract <<- resrob[4]
	ttime <<- resrob[5]
}
