      SUBROUTINE SUBSEQUENCEPATH(N,A,TIMTOT,R,U,T,V)
      IMPLICIT INTEGER(A-Z)
      DOUBLE PRECISION TIMEA,TIMEB,TIMTOT,A(N,N),EPS
      REAL S1
      INTEGER X(N),Q(N),S(N),T(R),U(R,N)
C
C #################################################################
C This program will extract the R largest subsequences of objects
C such that the edge-weights between adjacent pairs of objects in the
C subsequence are monotonically non-increasing (and exceed zero). More
C precisely, for any three consecutive objects (i, j, k) in the subsequence,
C we must have a(i,j) >= a(j,k), and a(j,k) > 0.  
C #################################################################
C
      EPS = 1.0d-07
      call cpu_time(timea)
      DO I = 1,N
        A(I,I) = 0.0D0
      END DO
C
      DO 1100 IJK = 1,R
      Z = 0
      DO I = 1,N
        Q(I) = 0
        S(I) = 0
        X(I) = 0
      END DO
C
      M=1
      Q(M)=1
      S(1)=1
      DO K = 2,N
        Q(K)=0
      END DO
C
  1   M = M + 1
C
  2   Q(M)=Q(M)+1
C
      IF(S(Q(M)).EQ.1) GO TO 2               ! REDUNDANCY
      IF(M.EQ.1.AND.Q(M).GT.N) GO TO 9       ! TERMINATE
      IF(M.GT.1.AND.Q(M).GT.N) GO TO 7       ! GO TO RETRACTION
      S(Q(M))=1
      IF(M.GT.2) THEN
        R3 = Q(M-2)
        R2 = Q(M-1)
        R1 = Q(M)
        IF(V.GT.0) THEN
          IF(Q(1).NE.V) THEN
            S(Q(M))=0
            GO TO 2
          END IF
        END IF
        IF(A(R3,R2).LT.A(R2,R1).OR.A(R2,R1).EQ.0) THEN
          S(Q(M))=0
          GO TO 2
        END IF
      END IF
      IF(M.GT.Z) THEN
        IDUP = 0;
        DO I = 1,IJK-1
          IF(T(I).EQ.M) THEN
            ICT = 0
            DO J = 1,M
              IF(U(I,J).EQ.Q(J)) ICT = ICT + 1
            END DO
          END IF
          IF(ICT.EQ.M) IDUP = 1
        END DO
        IF(IDUP.EQ.0) THEN   
          Z = M
          DO I = 1,N
            X(I)=Q(I)
          END DO
        END IF
      END IF
      GO TO 1
C
   7  S(Q(M))=0
      Q(M)=0
      M=M-1
      S(Q(M))=0
      GO TO 2
   9  CONTINUE
C
      T(IJK) = Z
      DO J = 1,Z
        U(IJK,J) = X(J)
      END DO
 1100 CONTINUE
      call cpu_time(timea)
      TIMTOT=TIMEB-TIMEA
C
      END
